> ## Documentation Index
> Fetch the complete documentation index at: https://developers.fireblocks.com/llms.txt
> Use this file to discover all available pages before exploring further.

<AgentInstructions>

## Submitting Feedback

If you encounter incorrect, outdated, or confusing documentation on this page, submit feedback:

POST https://developers.fireblocks.com/feedback

```json
{
  "path": "/api-reference/contract-interactions/return-deployed-contracts-abi",
  "feedback": "Description of the issue"
}
```

Only submit feedback when you have something specific and actionable to report.

</AgentInstructions>

# Return deployed contract's ABI

> Return deployed contract's ABI by blockchain native asset id and contract address.
Endpoint Permission: Admin, Non-Signing Admin, Signer, Approver, Editor, and Viewer.



## OpenAPI

````yaml https://docs.fireblocks.com/api/v1/swagger.yaml get /contract_interactions/base_asset_id/{baseAssetId}/contract_address/{contractAddress}/functions
openapi: 3.0.0
info:
  title: Fireblocks API
  description: >
    Fireblocks provides a suite of applications to manage digital asset
    operations and a complete development platform to build your business on the
    blockchain.


    - Visit our website for more information: [Fireblocks
    Website](https://fireblocks.com)

    - Visit our developer docs: [Fireblocks
    DevPortal](https://developers.fireblocks.com)
  version: 1.6.2
  contact:
    email: developers@fireblocks.com
servers:
  - url: https://api.fireblocks.io/v1
    description: Fireblocks Production Environment Base URL
  - url: https://sandbox-api.fireblocks.io/v1
    description: Fireblocks Sandbox Environment Base URL
security: []
paths:
  /contract_interactions/base_asset_id/{baseAssetId}/contract_address/{contractAddress}/functions:
    get:
      tags:
        - Contract Interactions
      summary: Return deployed contract's ABI
      description: >-
        Return deployed contract's ABI by blockchain native asset id and
        contract address.

        Endpoint Permission: Admin, Non-Signing Admin, Signer, Approver, Editor,
        and Viewer.
      operationId: getDeployedContractAbi
      parameters:
        - $ref: '#/components/parameters/X-Idempotency-Key'
        - name: contractAddress
          required: true
          in: path
          description: The contract's onchain address
          example: '0xC2c4e1Db41F0bB97996D0eD0542D2170d146FB66'
          schema:
            type: string
        - name: baseAssetId
          description: The blockchain base assetId
          required: true
          in: path
          example: ETH
          schema:
            type: string
      responses:
        '200':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ContractAbiResponseDto'
        default:
          $ref: '#/components/responses/Error'
      x-codeSamples:
        - lang: TypeScript
          source: >-
            const response: Promise<FireblocksResponse<ContractAbiResponseDto>>
            =
            fireblocks.contractInteractions.getDeployedContractAbi(contractInteractionsApiGetDeployedContractAbiRequest);
        - lang: Java
          source: >-
            CompletableFuture<ApiResponse<ContractAbiResponseDto>> response =
            fireblocks.contractInteractions().getDeployedContractAbi(contractAddress,
            baseAssetId, idempotencyKey);
        - lang: Python
          source: >-
            response =
            fireblocks.contract_interactions.get_deployed_contract_abi(contract_address,
            base_asset_id, idempotency_key);
components:
  parameters:
    X-Idempotency-Key:
      name: Idempotency-Key
      in: header
      description: >-
        A unique identifier for the request. If the request is sent multiple
        times with the same idempotency key, the server will return the same
        response as the first request. The idempotency key is valid for 24
        hours.
      required: false
      schema:
        type: string
  schemas:
    ContractAbiResponseDto:
      type: object
      properties:
        abi:
          example:
            - inputs:
                - internalType: address
                  name: implementation
                  type: address
                - internalType: bytes
                  name: _data
                  type: bytes
              stateMutability: nonpayable
              type: constructor
          description: The abi of the contract
          type: array
          items:
            oneOf:
              - $ref: '#/components/schemas/AbiFunction'
              - $ref: '#/components/schemas/SolanaInstruction'
        implementationAbi:
          example:
            - inputs:
                - internalType: address
                  name: to
                  type: address
                - internalType: uint256
                  name: amount
                  type: uint256
              stateMutability: nonpayable
              type: function
              name: mint
          description: >-
            The abi of the implementation contract if exists. Relevant only for
            proxy patterns
          type: array
          items:
            $ref: '#/components/schemas/AbiFunction'
      required:
        - abi
    AbiFunction:
      type: object
      properties:
        name:
          type: string
          example: mint
          description: The name of the contract function as it appears in the ABI
        stateMutability:
          type: string
          example: pure
          enum:
            - pure
            - view
            - nonpayable
            - payable
          description: >-
            The state mutability of the contract function as it appears in the
            ABI
        type:
          type: string
          example: constructor
          description: The type of the function
          enum:
            - constructor
            - function
            - error
            - event
            - receive
            - fallback
        inputs:
          description: The parameters that this function/constructor posses
          items:
            $ref: '#/components/schemas/Parameter'
          type: array
        outputs:
          description: The parameters that this 'read' function returns
          items:
            $ref: '#/components/schemas/Parameter'
          type: array
        description:
          type: string
          description: The documentation of this function (if has any)
      required:
        - type
    SolanaInstruction:
      type: object
      properties:
        name:
          type: string
          description: The name of the instruction
          example: transfer
        discriminator:
          type: array
          items:
            type: number
          description: The discriminator for the instruction. Acts as a function selector
          example:
            - 13
        accounts:
          type: array
          items:
            $ref: '#/components/schemas/SOLAccount'
        args:
          type: array
          items:
            $ref: '#/components/schemas/SolParameter'
      required:
        - name
        - discriminator
        - accounts
        - args
    ErrorSchema:
      type: object
      properties:
        message:
          type: string
        code:
          type: number
    Parameter:
      type: object
      properties:
        name:
          type: string
          example: _name
          description: The name of the parameter as it appears in the ABI
        description:
          type: string
          example: The name of the token
          description: >-
            A description of the parameter, fetched from the devdoc of this
            contract
        internalType:
          type: string
          example: string
          description: The internal type of the parameter as it appears in the ABI
        type:
          type: string
          example: string
          description: The type of the parameter as it appears in the ABI
        components:
          type: array
          items:
            $ref: '#/components/schemas/Parameter'
      required:
        - name
        - type
    SOLAccount:
      type: object
      description: The accounts involved in the instruction
      properties:
        name:
          type: string
          description: The name of the account
          example: mint
        signer:
          type: boolean
          description: >-
            Indicates if the account needs to sign the instruction. If true a
            signature for this account must be provided
          example: false
        writable:
          type: boolean
          description: Indicates if the account's data can be changed by the instruction.
          example: true
        address:
          type: string
          description: The address of the account
          example: 4PVcDXAkAgQkVx4puiSXdZ5H8BrTqUzstJBKKWFy3XsH
      required:
        - name
    SolParameter:
      type: object
      description: The arguments of the instruction
      properties:
        name:
          type: string
          description: The name of the parameter
          example: mint
        type:
          $ref: '#/components/schemas/IdlType'
      required:
        - name
        - type
    IdlType:
      type: string
      enum:
        - bool
        - u8
        - i8
        - u16
        - i16
        - u32
        - i32
        - f32
        - u64
        - i64
        - f64
        - u128
        - i128
        - u256
        - i256
        - bytes
        - string
        - pubkey
      description: The type of the parameter
      example: u8
  responses:
    Error:
      description: Error Response
      headers:
        X-Request-ID:
          $ref: '#/components/headers/X-Request-ID'
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorSchema'
  headers:
    X-Request-ID:
      schema:
        type: string
      description: >-
        Unique ID correlated to the API request. Please provide it in any
        support ticket you create or on Github issues related to Fireblocks SDKs

````